@echo off

set version=0.5.4

echo set bin_version %version% > bin\binversion.tcl

set tclfiles=lib\blankcell.tcl
set tclfiles=%tclfiles% lib\burn.tcl lib\calculator.tcl lib\cmdedit.tcl lib\disasm.tcl lib\utils.tcl
set tclfiles=%tclfiles% lib\fontreq.tcl lib\macros.tcl lib\main.tcl lib\menued.tcl lib\pgceditor.tcl
set tclfiles=%tclfiles% lib\readdvd.tcl lib\srptinfo.tcl lib\streams.tcl
set tclfiles=%tclfiles% lib\stringreq.tcl lib\tk_menu_bugfix.tcl lib\toolbar.tcl lib\trace.tcl
set tclfiles=%tclfiles% lib\toolscfg.tcl lib\writedvd.tcl lib\winshellext.tcl
set tclfiles=%tclfiles% lib\menubuttons.tcl

set files=%tclfiles%
set files=%files% lib\data\blank_ntsc_720.vob lib\data\blank_pal_720.vob
set files=%files% lib\data\blank_ntsc_704.vob lib\data\blank_pal_704.vob
set files=%files% lib\data\blank_ntsc_352.vob lib\data\blank_pal_352.vob
set files=%files% lib\data\blank_ntsc_352v.vob lib\data\blank_pal_352v.vob
set files=%files% lib\data\new_dvd_video_ts.ifo
set files=%files% lib\data\vmg_txtdt_mg_default.sec
set files=%files% lib\data\vmgm_pgci_ut_wo_vob.sec
set files=%files% lib\data\lang_codes.txt
set files=%files% lib\icons\sweetness\burn_dvd.gif
set files=%files% lib\icons\sweetness\calculator_converter.gif
set files=%files% lib\icons\sweetness\check_dvd_size.gif
set files=%files% lib\icons\sweetness\create_backup.gif
set files=%files% lib\icons\sweetness\enable_all_operations.gif
set files=%files% lib\icons\sweetness\explore_dvd_folder.gif
set files=%files% lib\icons\sweetness\find_unused_gprms.gif
set files=%files% lib\icons\sweetness\kill_pgc_playback.gif
set files=%files% lib\icons\sweetness\new_dvd.gif
set files=%files% lib\icons\sweetness\new_pgc.gif
set files=%files% lib\icons\sweetness\open_dvd.gif
set files=%files% lib\icons\sweetness\open_scratchbook.gif
set files=%files% lib\icons\sweetness\preview.gif
set files=%files% lib\icons\sweetness\region_code.gif
set files=%files% lib\icons\sweetness\reopen_dvd.gif
set files=%files% lib\icons\sweetness\restore_backup.gif
set files=%files% lib\icons\sweetness\save_dvd.gif
set files=%files% lib\icons\sweetness\save_scratchbook.gif
set files=%files% lib\icons\sweetness\set_dvd_text.gif
set files=%files% lib\icons\sweetness\set_provider_id.gif
set files=%files% lib\icons\sweetness\show_menu_buttons.gif
set files=%files% lib\icons\sweetness\streams_attributes.gif
set files=%files% lib\icons\sweetness\title_play_map_table.gif
set files=%files% lib\icons\sweetness\trace.gif
set files=%files% COPYING.txt README.txt LISEZMOI.txt TODO.txt HISTORY.txt

set winfiles=lib\preview.tcl bin\pskill.exe bin\PgcEditPreview.exe
rem set winfiles=%winfiles% bin\pkgIndex.tcl bin\tkimg13.dll bin\tkimgbmp13.dll

echo PgcEdit version %version%

echo .
echo Converting PgcEdit.tcl to Unix format...
DOS2UNIX PgcEdit.tcl

echo .
echo Making source zip archive...
del PgcEdit_source.zip
if ERRORLEVEL 1 goto ERROR
wzzip -a+ -P -ex PgcEdit_source.zip PgcEdit.tcl lib\icons\PgcEdit.ico %files% %winfiles% bin\binversion.tcl wrap.cmd PgcEdit_project.prj
if ERRORLEVEL 1 goto ERROR

echo .
echo Making windoze executable...
echo freewrap.exe PgcEdit.tcl -i lib\icons\PgcEdit.ico %files% %winfiles%
C:\Tcl\freeWrap\freewrap.exe PgcEdit.tcl -i lib\icons\PgcEdit.ico %files% %winfiles%
if ERRORLEVEL 1 goto ERROR

echo .
echo Making linux executable...
echo freewrap.exe PgcEdit.tcl -w freewrap %files%
rem C:\Tcl\freeWrap\freewrap.exe PgcEdit.tcl -w C:\Tcl\freeWrap\freewrap %files%
C:\Tcl\freeWrap\freewrap.exe PgcEdit.tcl -w C:\Tcl\freeWrap\freewrap %files%
if ERRORLEVEL 1 goto ERROR
ren PgcEdit pgcedit

echo .
echo Making windoze executable archive...
del "PgcEdit_winexe.zip"
if ERRORLEVEL 1 goto ERROR
wzzip -a+ -P -ex "PgcEdit_winexe.zip" PgcEdit.exe
if ERRORLEVEL 1 goto ERROR

echo .
echo Making Linux executable archive...
del "PgcEdit_linux_exe.zip"
if ERRORLEVEL 1 goto ERROR
wzzip -a+ -P -ex "PgcEdit_linux_exe.zip" pgcedit
if ERRORLEVEL 1 goto ERROR

echo .
echo Copying source and executables on homepage image...
copy PgcEdit.exe "C:\Documents and Settings\Rol\My Documents\Homepage\home\pgcedit\pgcedit.exe"
if ERRORLEVEL 1 goto ERROR
copy PgcEdit_winexe.zip "C:\Documents and Settings\Rol\My Documents\Homepage\home\pgcedit\pgcedit_winexe.zip"
if ERRORLEVEL 1 goto ERROR
copy pgcedit "C:\Documents and Settings\Rol\My Documents\Homepage\home\pgcedit\pgcedit"
if ERRORLEVEL 1 goto ERROR
copy PgcEdit_source.zip "C:\Documents and Settings\Rol\My Documents\Homepage\home\pgcedit\pgcedit_source.zip"
if ERRORLEVEL 1 goto ERROR

echo .
echo Copying source and executables on homepage/versions image...
copy PgcEdit_source.zip "C:\Documents and Settings\Rol\My Documents\Homepage\home\pgcedit\versions\PgcEdit_source_%version%.zip"
if ERRORLEVEL 1 goto ERROR
copy PgcEdit_winexe.zip "C:\Documents and Settings\Rol\My Documents\Homepage\home\pgcedit\versions\PgcEdit_winexe_%version%.zip"
if ERRORLEVEL 1 goto ERROR
copy PgcEdit_linux_exe.zip "C:\Documents and Settings\Rol\My Documents\Homepage\home\pgcedit\versions\PgcEdit_linux_exe_%version%.zip"
if ERRORLEVEL 1 goto ERROR

echo .
echo Copying text files on homepage image...
copy README.txt   "C:\Documents and Settings\Rol\My Documents\Homepage\home\pgcedit\"
if ERRORLEVEL 1 goto ERROR
copy LISEZMOI.txt "C:\Documents and Settings\Rol\My Documents\Homepage\home\pgcedit\"
if ERRORLEVEL 1 goto ERROR
copy HISTORY.txt  "C:\Documents and Settings\Rol\My Documents\Homepage\home\pgcedit\"
if ERRORLEVEL 1 goto ERROR

echo .
echo Backuping the sources...
copy PgcEdit_source.zip "D:\PgcEdit_backup\PgcEdit_source_%version%.zip"
if ERRORLEVEL 1 goto ERROR
copy PgcEdit_source.zip "C:\Documents and Settings\Rol\My Documents\My Scripts\Tcl-Tk\PGCEdit\PgcEdit_source_%version%.zip"
if ERRORLEVEL 1 goto ERROR

echo .
echo Installing PgcEdit...
copy PgcEdit.exe "C:\program files\PgcEdit\"
if ERRORLEVEL 1 goto ERROR
copy PgcEdit.exe "C:\Tcl\work\PGCEDIT\executables\PgcEdit_%version%.exe"
if ERRORLEVEL 1 goto ERROR

echo .
echo Done building PgcEdit %version%
echo Close this window now, or press any key to generate the TclChecker error file.
pause >NUL:

echo .
echo Generating TclChecker error file...
C:\Tcl\bin\tclsh C:\Tcl\bin\tclchecker.tcl %tclfiles% lib\preview.tcl PgcEdit.tcl > TclChecker_errors.txt
rem start PgcEdit
exit

:ERROR
echo ###################################################
echo ####### WARNING: PgcEdit make batch failed! #######
echo ###################################################
pause >NUL:
exit
